/////////////////////////////////////////////////////////////////
//Aufgabe 4  Kapitel Fraktale
//////////////////////////////////////////////////////////////

//Winkelzunahme alpha (im Bogenmass) pro Iteration
float alpha = 1.111;
//Bildausschnitt zu Beginn: 
//Zentrieren und entzerren mit :
float xU =-0.32; //-1
float xO = 0.32; // 1
float yU =-0.32; // -1
float yO = 0.32; //1
//Für starkes Zoomen müssen sehr viele Iterationen durchgeführt werden.
//Damit die Fehler dabei nicht zu groß werden, sollte man mit double-Werten 
// rechnen
double dx ;
double dy ;
int nOrbits; // Anzahl Orbits mit unterschiedlichem Radius
int nPoints ; // Punkte pro Orbit
// Hilfsvariablen:
int punkteZaehler = 0;
double xH; //aktueller x-Startwert
double yH; //aktueller y-Startwert

///////////////////////////////////////////////////////////////////////////
//Initialisierungen  
///////////////////////////////////////////////////////////////////////////
void setup() { 
  size(800, 800);
  background(0);
  colorMode(HSB);
  println("alpha = "+alpha);
  dx = 0.001;
  dy = 0.001;//Startpunkte Änderungen
  xH = 0;
  yH = 0;
  nOrbits = 1000; 
  nPoints = 4000; 
}
//////////////////////////////////////////////////////////
//Iteration
/////////////////////////////////////////////////////////
void iteriere(double xAlt,double yAlt) {  
  int i=0;
  stroke(color( punkteZaehler % 256, 255, 255));
  while (i <=nOrbits) {
    if (Math.abs(xAlt)< 100000 && Math.abs(yAlt)< 100000) {
      double xNeu = xAlt*cos(alpha)-(yAlt-xAlt*xAlt)*sin(alpha); 
      double yNeu = xAlt*sin(alpha)+(yAlt-yAlt*xAlt)*cos(alpha);   
      float xK = round(map((float)xNeu,(float) xU, (float)xO, 0, width));                 
      float yK = round(map((float)yNeu,(float) yU, (float)yO, height, 0));    
      //if(xNeu>xU && xNeu<xO && yNeu>yU && yNeu<yO )point(xK, yK); //was ist schneller 
      point(xK, yK);
      xAlt = xNeu;
      yAlt = yNeu;    
    }   
    i++;
  }
}
///////////////////////////////////////////////////////////////////////////
void draw() {
  //Fraktal zeichnen
  iteriere(xH,yH); 
  punkteZaehler++;
 
  xH = xH + dx; 
  yH = yH + dy;//nächster Startpunkt
  if (punkteZaehler>=nPoints) {
    println("alle Punkte gesetzt, fertig"); 
    noLoop();
  }
  if (abs((float)xH) >= 3 && abs((float)yH) >=2) {
    println("äussere Grenze erreicht, fertig");
    noLoop();
  }
}
///////////////////////////////////////////////////////////////////////////
//Restart
///////////////////////////////////////////////////////////////////////
void restart(int aOrbits){
  background(0);
  alpha = random(0,2*PI);
  println("alpha = "+alpha);
  xU =-0.32; //-1
  xO = 0.32; // 1
  yU =-0.32; // -1
  yO = 0.32; //1
  punkteZaehler = 0;
  xH = 0;//xStart;
  yH = 0;// yStart; 
  dx = 0.001;
  dy = 0.001;//Startpunkte Änderung
  nOrbits = aOrbits; 
  nPoints = 4000; 
  
}
//////////////////////////////////////
void keyPressed() {  
  if (key == 'n') {
     if(nOrbits == 100) restart(100);
     else restart(1000);
     println(xU,xO,yU,yO,xO-xU,nOrbits);
  }  
  if(key == '1'){
    if(nOrbits==1000)nOrbits =100;
    else nOrbits =1000;
  }
  
  if (key == 's') save("image.png");
} 
/////////////////////////////////////////////////////
//Die Stelle, auf die man klickt wird vergrößert
//////////////////////////////////////////////////////
void mousePressed() {  
  background(0);
  float xUNeu = map(mouseX, 0, width, xU, xO)-(xO-xU)/5;
  float xONeu = map(mouseX, 0, width, xU, xO)+(xO-xU)/5;
  float yUNeu = map(mouseY, 0, height, yO, yU)-(yO-yU)/5;
  float yONeu = map(mouseY, 0, height, yO, yU)+(yO-yU)/5;
  xU = xUNeu; 
  xO = xONeu; 
  yU = yUNeu; 
  yO = yONeu;
  xH = 0;
  yH = 0;
  dx = dx/2;
  dy = dy/2; //falls in den Chaosbereich gezoomt werden soll
  nOrbits =int(nOrbits*2); 
  punkteZaehler = 0;
  println(xU,xO,yU,yO,xO-xU,nOrbits);
  loop();
}
